Index: trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh
===================================================================
--- trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh	(revision 1187)
+++ trunk/examples/extended/electromagnetic/TestEm7/include/c2_function.hh	(revision 1230)
@@ -1236,24 +1837,26 @@
 		float_type intercept, center, a, b;
 protected:
-		c2_quadratic() {} // do not allow naked construction... it is usually an accident.
+		c2_quadratic_p() {} // do not allow naked construction... it is usually an accident.
 };
 
 /**
 \brief create a power law mapping of another function 
- 
+ \ingroup parametric_functions
  for example, given a c2_function \a f 
  \code 
- c2_power_law<double> PLaw(1.2, 2.5);
- c2_composed_function<double> &F=PLaw(f); 
+ c2_power_law_p<double> PLaw(1.2, 2.5);
+ c2_composed_function_p<double> &F=PLaw(f); 
  \endcode
  produces a new c2_function F=1.2 * f^2.5 
  
+ The factory function c2_factory::power_law() creates *new c2_power_law_p
  */
-template <typename float_type=double> class c2_power_law : public c2_function<float_type> {
+template <typename float_type=double> class c2_power_law_p : public c2_function<float_type> {
 public:
     /// \brief Construct the operator
     /// \param scale the multipler
     /// \param power the exponent
-	c2_power_law(float_type scale, float_type power) : a(scale), b(power) {}
+	c2_power_law_p(float_type scale, float_type power) :
+		c2_function<float_type>(), a(scale), b(power) {}
     /// \brief Modify the mapping after construction
     /// \param scale the new multipler
@@ -1266,10 +1869,10 @@
 		float_type a, b;
 protected:
-		c2_power_law() {} // do not allow naked construction... it is usually an accident.
+		c2_power_law_p() {} // do not allow naked construction... it is usually an accident.
 };
 
 /**
 \brief create the formal inverse function of another function 
- 
+ \ingroup containers
  for example, given a c2_function \a f 
  \code 
@@ -1282,12 +1885,14 @@
  derivatives, too, unlike the case of a simple root-finding inverse.  This means
  it can be integrated (for example) quite efficiently.
- 
- Note that it is a subclass of c2_scaled_function only to manage ownership of another c2_function.
- */
-template <typename float_type=double> class c2_inverse_function : public c2_plugin_function<float_type> {
+
+ \see \ref combined_inversion_hinting_sampling
+
+ The factory function c2_factory::inverse_function() creates *new c2_inverse_function_p
+*/
+template <typename float_type=double> class c2_inverse_function_p : public c2_function<float_type> {
 public:
     /// \brief Construct the operator
     /// \param source the function to be inverted
-	c2_inverse_function(const c2_function<float_type> &source);  
+	c2_inverse_function_p(const c2_function<float_type> &source);  
     virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw(c2_exception);
     
@@ -1301,15 +1906,43 @@
     ///  It is used in value_with_derivatives() to guess where to start the root finder.
     /// \param x the abscissa for which an estimate is needed
-    virtual float_type get_start_hint(float_type x) const { return start_hint; } 
-    
+    virtual float_type get_start_hint(float_type x) const 
+		{ return hinting_function.valid()? hinting_function(x) : start_hint; } 
+
+	/// \brief set or unset the approximate function used to start the root finder
+	/// \anchor set_hinting_function_discussion
+	/// A hinting function is mostly useful if the evaluation of this inverse is
+	/// going to be carried out in very non-local order, so the root finder has to start over 
+	/// for each step.  If most evaluations are going to be made in fairly localized clusters (scanning
+	/// through the function, for example), the default mechanism used (which just remembers the last point)
+	/// is almost certainly faster.
+	/// 
+	/// Typically, the hinting function is likely to be set up by creating the inverse function,
+	/// and then adaptively sampling an interpolating function from it, and then using the result
+	/// to hint it.  Another way, if the parent function is already an interpolating function, is just to create
+	/// a version of the parent with the x & y coordinates reversed.
+	/// 
+	/// \see \ref combined_inversion_hinting_sampling
+	///
+	/// \param hint_func the function that is an approximate inverse of the parent of this inverse_function
+	void set_hinting_function(const c2_function<float_type> *hint_func) 
+		{ hinting_function.set_function(hint_func); }
+    /// \brief set the hinting function from a pointer.
+	/// 
+	/// See \ref set_hinting_function_discussion "discussion"
+	/// \param hint_func the container holding the function
+	void set_hinting_function(const c2_const_ptr<float_type> hint_func) 
+		{ hinting_function=hint_func; }
+	
 protected:
-    c2_inverse_function() {} // do not allow naked construction... it is usually an accident.
-    mutable float_type start_hint;
+	c2_inverse_function_p() {} // do not allow naked construction... it is usually an accident.
+	mutable float_type start_hint;
+	const c2_const_ptr<float_type> func;
+	c2_const_ptr<float_type> hinting_function;
 };
 
 /** 
   \brief
-    An interpolating_function  which is the cumulative integral of a histogram.
-
+    An interpolating_function_p  which is the cumulative integral of a histogram.
+	\ingroup interpolators
     Note than binedges should be one element longer than binheights, since the lower & upper edges are specified. 
     Note that this is a malformed spline, since the second derivatives are all zero, so it has less continuity.
@@ -1318,5 +1951,5 @@
 */
 
-template <typename float_type=double>  class accumulated_histogram : public interpolating_function <float_type> {
+template <typename float_type=double>  class accumulated_histogram : public interpolating_function_p <float_type> {
 public:
     /// \brief Construct the integrated histogram
@@ -1332,79 +1965,50 @@
 
 /**
-  \brief Construct a function useful for generation of random numbers from the given distribution
-  
-  inverse_integrated_density<InterpolatingFunctionFlavor>() starts with a probability density c2_function, generates the integral, 
-  and generates an interpolating_function  which, when evaluated using a uniform random on [0,1] returns values
-  with a density distribution equal to the input distribution
-  If the data are passed in reverse order (large X first), the integral is carried out from the big end.
+	\anchor inverse_integrated_density_bins
+	\brief construct from a grid of points and an std::vector of probability densities (un-normalized)
+	\see  \ref random_subsec "Arbitrary random generation"
+	\ingroup interpolators
+	 inverse_integrated_density starts with a probability density  std::vector, generates the integral, 
+	 and generates an interpolating_function_p  of the inverse function which, when evaluated using a uniform random on [0,1] returns values
+	 with a density distribution equal to the input distribution
+	 If the data are passed in reverse order (large X first), the integral is carried out from the big end.
+	 
+	\param bins if \a bins .size()==\a binheights .size(), the centers of the bins.  \n
+	if \a bins .size()==\a binheights .size()+1, the edges of the bins
+	\param binheights a vector which describes the density of the random number distribution to be produced.
+	Note density... the numbers in the bins are not counts, but counts/unit bin width.
+	\return an interpolating_function_p  of the type requested in the template which,
+	if evaluated randomly with a uniform variate on [0,1] produces numbers
+	distributed according to \a binheights
+*/
+
+template <typename float_type, typename Final> 
+interpolating_function_p<float_type> & inverse_integrated_density_bins(
+		const std::vector<float_type> &bins, const std::vector<float_type> &binheights) 
+		throw(c2_exception);
+
+/**
+\anchor inverse_integrated_density_function
+	\brief construct from a grid of points and a c2_function of probability densities (un-normalized)
+	\see  \ref random_subsec "Arbitrary random generation"
+	\ingroup interpolators 
+ inverse_integrated_density starts with a probability density  std::vector, generates the integral, 
+ and generates an interpolating_function_p  of the inverse function which, when evaluated using a uniform random on [0,1] returns values
+ with a density distribution equal to the input distribution
+ If the data are passed in reverse order (large X first), the integral is carried out from the big end.
  
-  \sa  template <typename Intermediate, typename Final> Final inverse_integrated_density(const std::vector, c2_function &)
- 
-  \param bincenters points at which to sample the c2_function \a binheights
-  \param binheights a c2_function which describes the random number distribution to be produced.
-  \return an interpolating_function  of the type requested in the template which,
-     if evaluated randomly with a uniform variate on [0,1) produces numbers
-     distributed according to \a binheights
-*/
-
-template <typename float_type, typename Final > 
-	Final &inverse_integrated_density(const std::vector<float_type> &bincenters, c2_function<float_type> &binheights)
-{	
-	std::vector<float_type> integral;
-	
-	// integrate from first to last bin in original order, leaving results in integral
-	// ask for relative error of 1e-6 on each bin, with absolute error set to 0 (since we don't know the data scale).
-	float_type sum=binheights.partial_integrals(bincenters, &integral, 0.0, 1e-6); 
-	// the integral vector now has partial integrals... it must be accumulated by summing
-	integral.insert(integral.begin(), 0.0); // integral from start to start is 0
-	float_type scale=1.0/sum;
-	for(size_t i=1; i<integral.size(); i++) integral[i]=integral[i]*scale + integral[i-1];
-	integral.back()=1.0; // force exact value on boundary
-	
-	return  *new Final(integral, bincenters, 
-					   false, 1.0/(scale*binheights(bincenters.front() )), 
-					   false, 1.0/(scale*binheights(bincenters.back() ))
-					   ); // use integral as x axis in inverse function
-}
-
-/**
- \brief Construct a function useful for generation of random numbers from the given distribution
-
- \code
- template <typename Intermediate, typename Final> 
-     Final & inverse_integrated_density(const std::vector &bincenters, const std::vector &binheights) 
- \endcode
- is a variant of \code
- template <typename Final> 
-     Final & inverse_integrated_density(const std::vector &bincenters, c2_function &binheights)
- \endcode
- which takes two std::vectors and generates the intermediate interpolating_function  required for 
- inverse_integrated_density(), and then calls it.
-
- \param bincenters points at which \a binheights are defined
- \param binheights an std::vector which describes the random number distribution to be produced.
- \return an interpolating_function  of the type requested in the template which,
- if evaluated randomly with a uniform variate on [0,1) produces numbers
-  distributed according to \a binheights
-*/
-
-template <typename float_type, typename Intermediate, typename Final> Final
-    &inverse_integrated_density(const std::vector<float_type> &bincenters, const std::vector<float_type> &binheights) 
-{	
-	std::vector<float_type> be(bincenters), bh(binheights);
-	
-	if(be[1] < be[0]) { // reverse data for interpolator if x axis passed in backwards
-		std::reverse(be.begin(), be.end());
-		std::reverse(bh.begin(), bh.end());
-	}
-	
-	Intermediate temp(be, bh); // create a temporary interpolating_function  to integrate
-	Final &result=inverse_integrated_density<Final>(bincenters, temp);
-	
-	return result;
-}
+	\param bincenters the centers of the bins. 
+	\param binheights a c2_function which describes the density of the random number distribution to be produced.
+	\return an interpolating_function_p  of the type requested in the template which,
+	if evaluated randomly with a uniform variate on [0,1] produces numbers
+	distributed according to \a binheights
+ */
+template <typename float_type, typename Final> 
+interpolating_function_p<float_type>  & inverse_integrated_density_function(
+		const std::vector<float_type> &bincenters, const c2_function<float_type> &binheights)
+		throw(c2_exception);
 
 /// \brief create a c2_function which smoothly connects two other c2_functions.
-///
+/// \ingroup parametric_functions
 /// This takes two points and generates a polynomial which matches two c2_function arguments 
 /// at those two points, with two derivatives at each point, and an arbitrary value at the center of the 
@@ -1414,40 +2018,88 @@
 /// of order 5.  If \a auto_center is false, the value \a y1 is used at the midpoint, resulting in a 
 /// polynomial of order 6.
-template <typename float_type=double> class c2_connector_function : public c2_function<float_type> {
+///
+/// This is usually used in conjunction with c2_piecewise_function_p to assemble an apparently seamless 
+/// function from a series of segments. 
+/// \see \ref piecewise_applications_subsec "Sample Applications" and \ref c2_function::adaptively_sample() "Adaptive sampling"
+///
+/// The factory function c2_factory::connector_function() creates *new c2_connector_function_p
+template <typename float_type=double> class c2_connector_function_p : public c2_function<float_type> {
 public:	
-	/// \brief construct the container
-	/// \param f1 the function on the left side to be connected 
+	/// \brief construct the container from two functions
+	/// \param x0 the point at which to match \a f1 and its derivatives
+	/// \param f0 the function on the left side to be connected 
+	/// \param x2 the point at which to match \a f2 and its derivatives
 	/// \param f2 the function on the right side to be connected
-	/// \param x0 the point at which to match \a f1 and its derivatives
-	/// \param x2 the point at which to match \a f2 and its derivatives
 	/// \param auto_center if true, no midpoint value is specified.  If false, match the value \a y1 at the midpoint
 	/// \param y1 the value to match at the midpoint, if \a auto_center is false
-	/// \return a c2_function with domain (\a x0,\a x2) which smoothly connects \a f1 and \a f2
-	c2_connector_function(const c2_function<float_type> &f1, const c2_function<float_type> &f2, float_type x0, float_type x2, 
+	/// \return a c2_function with domain (\a x0,\a x2) which smoothly connects \a f0(x0) and \a f2(x2)
+	c2_connector_function_p(float_type x0, const c2_function<float_type> &f0, float_type x2, const c2_function<float_type> &f2, 
 			bool auto_center, float_type y1);
+	/// \brief construct the container from numerical values
+	/// \param x0 the position of the left edge
+	/// \param y0 the function derivative on the left boundary
+	/// \param yp0 the function second derivative on the left boundary
+	/// \param ypp0 the function value on the left boundary
+	/// \param x2 the position of the right edge
+	/// \param y2 the function derivative on the right boundary
+	/// \param yp2 the function second derivative on the right boundary
+	/// \param ypp2 the function value on the right boundary
+	/// \param auto_center if true, no midpoint value is specified.  If false, match the value \a y1 at the midpoint
+	/// \param y1 the value to match at the midpoint, if \a auto_center is false
+	/// \return a c2_function with domain (\a x0,\a x2) which smoothly connects the points described
+	/// \anchor c2_connector_raw_init_docs
+	c2_connector_function_p(
+		float_type x0, float_type y0, float_type yp0, float_type ypp0, 
+		float_type x2, float_type y2, float_type yp2, float_type ypp2, 
+		bool auto_center, float_type y1);
+	/// \brief construct the container from c2_fblock<float_type> objects
+	/// \param fb0 the left edge
+	/// \param fb2 the right edge
+	/// \param auto_center if true, no midpoint value is specified.  If false, match the value \a y1 at the midpoint
+	/// \param y1 the value to match at the midpoint, if \a auto_center is false
+	/// \return a c2_function with domain (\a fb0.x,\a fb2.x) which smoothly connects \a fb0 and \a fb2
+	c2_connector_function_p(
+		const c2_fblock<float_type> &fb0, 
+		const c2_fblock<float_type> &fb2, 
+		bool auto_center, float_type y1);
+
 	/// \brief destructor
-	virtual ~c2_connector_function();
+	virtual ~c2_connector_function_p();
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw (c2_exception);
 protected:
-	float_type fx1, fhinv, fdx, fy1, fa, fb, fc, fd, fe, ff;
-};
-
-
+	/// \brief fill container numerically
+	void init(
+		const c2_fblock<float_type> &fb0, 
+		const c2_fblock<float_type> &fb2, 
+		bool auto_center, float_type y1);
+
+	float_type fhinv, fy1, fa, fb, fc, fd, fe, ff;
+};
 
 /// \brief create a c2_function which is a piecewise assembly of other c2_functions.
-///
+/// \ingroup containers
 /// The functions must have increasing, non-overlapping domains.  Any empty space
 /// between functions will be filled with a linear interpolation.
+///
+/// \note If you want a smooth connection, instead of the default linear interpolation,
+/// create a c2_connector_function_p to bridge the gap.  The linear interpolation is intended 
+/// to be a barely intelligent bridge, and may never get used by anyone.
+///
 /// \note The creation of the container results in the creation of an explicit sampling grid.  
 /// If this is used with functions with a large domain, or which generate very dense sampling grids,
 /// it could eat a lot of memory.  Do not abuse this by using functions which can generate gigantic grids.
 /// 
-/// See c2_plugin_function for a discussion of how this might be used.
-template <typename float_type=double> class c2_piecewise_function : public c2_function<float_type> {
+/// \see \ref piecewise_applications_subsec "Sample Applications" \n
+/// c2_plugin_function_p page \n
+/// c2_connector_function_p page \n
+/// \ref c2_function::adaptively_sample() "Adaptive sampling"
+///
+/// The factory function c2_factory::piecewise_function() creates *new c2_piecewise_function_p
+template <typename float_type=double> class c2_piecewise_function_p : public c2_function<float_type> {
 public:	
 	/// \brief construct the container
-	c2_piecewise_function();
+	c2_piecewise_function_p();
 	/// \brief destructor
-	virtual ~c2_piecewise_function();
+	virtual ~c2_piecewise_function_p();
 	virtual float_type value_with_derivatives(float_type x, float_type *yprime, float_type *yprime2) const throw (c2_exception);
 	/// \brief append a new function to the sequence
@@ -1457,11 +2109,8 @@
 	/// the final function.  If the domain exactly abuts the domain of the previous function, it
 	/// will be directly attached.  If there is a gap, the gap will be filled in by linear interpolation.
-	/// If the function being appended is to be deleted automatically when this container is deleted, set the pass_ownership flag.
 	/// \param func a c2_function with a defined domain to be appended to the collection
-	/// \param pass_ownership if set, \a func will be deleted when the container is destroyed
-	void append_function(c2_function<float_type> &func, bool pass_ownership) throw (c2_exception);
+	void append_function(const c2_function<float_type> &func) throw (c2_exception);
 protected:
-	std::vector<c2_function<float_type> *> functions;
-	std::vector<bool> owns;
+	std::vector<c2_const_ptr<float_type> > functions;
 	mutable int lastKLow;
 };
